/*
guile-irrlicht --- GNU Guile bindings for Irrlicht Engine

Copyright (C) 2021 Javier Sancho <jsf@jsancho.org>

This file is part of guile-irrlicht.

guile-irrlicht is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as
published by the Free Software Foundation; either version 3 of the
License, or (at your option) any later version.

guile-irrlicht is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with guile-irrlicht. If not, see
<http://www.gnu.org/licenses/>.
*/

%module irrlicht
%{
#include <irrlicht/irrlicht.h>
using namespace irr;
using namespace core;
using namespace scene;
using namespace video;
using namespace io;
using namespace gui;
%}

typedef int s32;
typedef unsigned int u32;
typedef float f32;
typedef double f64;

%rename(add) operator+;
%rename(substract) operator-;
%rename(product) operator*;
%rename(divide) operator/;
%rename(equal) operator==;
%ignore operator+=;
%ignore operator-=;
%ignore operator*=;
%ignore operator/=;
%ignore operator!=;

%include dimension2d.h
%template(dimension2df) irr::core::dimension2d<irr::f32>;
%template(dimension2ds) irr::core::dimension2d<irr::s32>;
%template(dimension2du) irr::core::dimension2d<irr::u32>;

%rename("%(undercase)s", %$not %$isconstant, %$not %$isenumitem) "";
%feature("constasvar");

%include EDriverTypes.h
%include IrrCompileConfig.h
%include irrlicht.h

%scheme %{ (load-extension "libguile-irrlicht" "scm_init_irrlicht_module") %}
